function ELToggleDiv(id) {
    if (ExpandContract == 1) {
        var element = document.getElementById(id);
        var info = document.getElementById(id + "_info");
        var arrow = document.getElementById(id + "_arrow");

        if (parseInt(element.offsetHeight) > 45) {
            element.style.height = "45px";
            info.style.visibility = "hidden";
            element.setAttribute("isExpanded", "contracted");
            arrow.src = "resources/images/arrow_icon.png";
        } else {
            element.style.height = "auto";
            info.style.visibility = "visible";
            element.setAttribute("isExpanded", "expanded");
            arrow.src = "resources/images/arrow_icon_expanded.png";
        }

        saveState();
    }
}

function saveState() {
    var statearray = [new NSMutableDictionary init];
    statearray.missed_calls = document.getElementById('missed_calls').getAttribute('isExpanded');
    statearray.calendar_events = document.getElementById('calendar_events').getAttribute('isExpanded');
    statearray.email = document.getElementById('email').getAttribute('isExpanded');
    statearray.sms = document.getElementById('sms').getAttribute('isExpanded');
    statearray.facebook = document.getElementById('facebook').getAttribute('isExpanded');
    statearray.stocks = document.getElementById('stocks').getAttribute('isExpanded');
    [statearray writeToFile:"/User/Library/Element/cache/laststate.Element" atomically:YES];
}

function CFAutoString(object) {
    if (object == null)
        return object;
    var string = object.toString();
    CFRelease(object);
    return string;
}

function CFAutoObject(object) {
    if (object == null)
        return null;
    var instance = new Instance(object);
    CFRelease(object);
    return instance;
}

function decomposedString(key, value) {
    var string = [bundle localizedStringForKey:key value:value table:"SpringBoard"];
    return [[NSString stringWithString:string] decomposedStringWithCanonicalMapping].toString();
}

function ELPrintDate(date, color) {
    document.write('<dt>');

    if (typeof(color) != "undefined" && color != null) {
        document.write('<div class="dot" style="background-color: ');
        document.write(color);
        document.write(';"><img src="resources/images/icon_dot_overlay.png" width="8" height="7" /></div>');
    }

    CFDateFormatterSetFormat(formatter, UIDateFormatStringForFormatType(UIDatePickerDayFormat));

    var dayofevent = CFDateFormatterCreateStringWithDate(NULL, formatter, date);
    dayofevent = CFAutoString(dayofevent);

    var daynow = CFDateFormatterCreateStringWithDate(NULL, formatter, now);
    daynow = CFAutoString(daynow);

    CFDateFormatterSetFormat(formatter, UIDateFormatStringForFormatType(UINoAMPMTimeFormat));

    var string = CFDateFormatterCreateStringWithDate(NULL, formatter, date);
    string = CFAutoString(string);

    if (parseInt(daynow) == parseInt(dayofevent)) {
        document.write(string);
    } else if ((daynow - dayofevent) == 1) {
        var stringform = "1";
        document.write("<span class='grey'>" + yesterdayString + "</span>");
    } else {
        diff2 = daynow - dayofevent;

        if (diff2 > 0) {
            var stringform = "1";
            document.write("<span class='grey'>" + diff2 + " " + daysAgoString + "</span>");
        } else {
            var stringform = "1";
            document.write("<span class='grey'>7+ " + daysAgoString + "</span>");
        }
    }

    if (stringform != "1") {
        document.write(' <span class="am_pm">');

        CFDateFormatterSetFormat(formatter, "a");
        var string = CFDateFormatterCreateStringWithDate(NULL, formatter, date);
        string = CFAutoString(string);
        document.write(string);

        document.write('</span></dt>');
    } else {
        document.write('</dt>');
    }
}

function ELSaveDate(date, color, stringdate) {
    var result = '<dt>';

    if (stringdate != null && stringdate != undefined) {
        if (date > now)
            color = "rgb(81, 187, 53)";
        else
            color = "rgb(246, 157, 9)";

        result += '<div class="dot" style="background-color: ' + color + ';"><img src="resources/images/icon_dot_overlay.png" width="8" height="7"/></div>';
    }

    if (typeof(color) != "undefined" && color != null && stringdate == null)
       result += '<div class="dot" style="background-color: ' + color + ';"><img src="resources/images/icon_dot_overlay.png" width="8" height="7"/></div>';

    CFDateFormatterSetFormat(formatter, UIDateFormatStringForFormatType(UIDatePickerDayFormat));

    var dayofevent2 = CFDateFormatterCreateStringWithDate(NULL, formatter, date);
    dayofevent2 = CFAutoString(dayofevent2);

    var daynow2 = CFDateFormatterCreateStringWithDate(NULL, formatter, now);
    daynow2 = CFAutoString(daynow2);

    CFDateFormatterSetFormat(formatter, UIDateFormatStringForFormatType(UINoAMPMTimeFormat));

    var string = CFDateFormatterCreateStringWithDate(NULL, formatter, date);
    string = CFAutoString(string);

    if (parseInt(daynow2) == parseInt(dayofevent2)) {
        result += string;
    } else if ((daynow2 - dayofevent2) == 1) {
        var stringform2 = "1";
        result += "<span class='grey'>" + yesterdayString + "</span>";
    } else {
        diff2 = daynow2 - dayofevent2;

        if (diff2 > 0) {
            var stringform2 = "1";
            result += "<span class='grey'>" + diff2 + " " + daysAgoString + "</span>";
        } else {
            var stringform2 = "1";

            if (typeof(stringdate) != "undefined" && stringdate != null)
                result += "<span class='grey'>" + tomorrowString + "</span>";
            else
                result += "<span class='grey'>7+ " + daysAgoString + "</span>";
        }
    }

    if (stringform2 != "1") {
        result += ' <span class="am_pm">';

        CFDateFormatterSetFormat(formatter, "a");

        var string = CFDateFormatterCreateStringWithDate(NULL, formatter, date);
        result += string;
        CFRelease(string);

        result += '</span>';
    }

    result += '</dt>';
    return result;
}

function getmail() {
    var library = [MailMessageLibrary defaultInstance];

    var currentmessage = "";
    var mailbadge = [[SBIconModel.sharedInstance iconForDisplayIdentifier:"com.apple.mobilemail"] badgeValue];

    if (mailbadge > 0)
        document.getElementById("mail_count").innerHTML = "(" + mailbadge + ")";

    var messages = [library messagesMatchingQuery:"select * from messages where read='0' and deleted='0' order by ROWID desc limit " + noOfEmails options:NULL];

    for (var i = 0; i != messages.count; ++i) {
        var message = messages[i];
        // XXX: why do we do this?!
        message = [library messageWithMessageID:message.messageID];

        sender = message.sender.toString();
        currentmessage += ELSaveDate(message.dateReceived);
        sender = sender.replace(/"/g, "");

        var body = message.messageBody;
        var data = [[[body htmlContent] objectAtIndex:0] htmlData];
        var part = [body topLevelPart];

        var text = '';

        var attachments = [part numberOfAttachments];
        if (attachments != 0) {
            text += "Attachments:" + attachments + " ";
            for (var attc = 0; attc != attachments; ++attc)
                text += [[part subpartAtIndex:(attc + 1)] attachmentFilename] + " ";
        }

        if (data != null)
            text += [new NSString initWithData:data encoding:1].toString();

        text = text.replace(/<script[^>]*>.*?<\/script>/gi, "");
        text = text.replace(/<style[^>]*>.*?<\/style>/gi, "");
        text = text.replace(/<STYLE>.*<\/STYLE>/gi, "");
        text = text.replace(/<\!--[^>]*>.*?<\/-->/gi, "");
        text = text.replace(/<\/?(?!\!)[^>]*>/gi, '');
        text = text.replace(/\n/g, "");
        text = text.replace(/\  /g, "");

        var subject = message.subject.toString();
        if (subject.length > 60) {
            subject = subject.substr(0, 60);
            subject += "...";
        }

        currentmessage += '<dl><dd>' + sender + '<span class="subject">' + subject + '<p class=mailbody>' + text + '</p></span></dd></dl>';

        document.getElementById('email_info').innerHTML = currentmessage;
        [currentmessage writeToFile:"/User/Library/Element/cache/latestmails.Element" atomically:YES];
    }
}

function checklockedmail() {
    var t = [new NSTask init]; [t setLaunchPath:"/usr/bin/sqlite3"];
    var path = "/User/Library/Mail/Envelope Index";
    [t setArguments:[path, ".tables"]];

    var p = [NSPipe pipe]; e = [NSPipe pipe]; [t setStandardOutput:p]; [t setStandardError:e]; [t launch];
    var s = [new NSString initWithData:[[p fileHandleForReading] readDataToEndOfFile] encoding:4];

    var se = [new NSString initWithData:[[e fileHandleForReading] readDataToEndOfFile] encoding:4];
    se = se.toString();

    if (se.search("locked") > -1) {
        document.getElementById("mail_count").innerHTML += ".";
        if (document.getElementById("mail_count").innerHTML == "....")
            document.getElementById("mail_count").innerHTML = ".";
        remail = setTimeout("checklockedmail()", 2000);
    } else {
        try { clearTimeout(remail); } catch(err) {}
        getmail();
    }
}

function getCalendar() {
    document.getElementById("calendar_events_info").innerHTML = "";
    var calendar = SBCalendarController.sharedInstance->_database;
    var calendarvars = "";
    var calendarvars2 = "";

    if (calendar != null) {
        var filter = CalFilterCreateWithDatabase(calendar);

        var start = CFAbsoluteTimeGetGregorianDate(time, zone);
        start.second = 0;
        start.minute = 0;
        start.hour = 0;

        //now and 24h+
        var end = CFAbsoluteTimeGetGregorianDate(time, zone);
        end.second = 86399;

        //today's only
        var end2 = CFAbsoluteTimeGetGregorianDate(time, zone);
        end2.hour = 23;
        end2.minute = 59;
        end2.second = 59;
        var occurrences2 = CalDatabaseCopyEventOccurrencesInDateRange(calendar, filter, start, end, zone);
        var occurrences = CalDatabaseCopyEventOccurrencesInDateRange(calendar, filter, start, end2, zone);

        colors = ['rgb(160, 2, 251)', 'rgb(246, 157, 9)', 'rgb(81, 187, 53)'];

        var events = [];
        var events2 = [];

        if (occurrences2 != null) {
            var time2 = CFAbsoluteTimeGetCurrent();

            var now2 = CFDateCreate(NULL, time2 + 86399);
            now2 = CFAutoObject(now2);

            CFDateFormatterSetFormat(formatter, UIDateFormatStringForFormatType(UIWeekdayNoYearDateFormat));

            var nextDay = CFDateFormatterCreateStringWithDate(NULL, formatter, now2);
            nextDay = CFAutoString(nextDay);

            nextDay = [[NSString stringWithString:nextDay] decomposedStringWithCanonicalMapping];
            calendarvars2 = "<h2 id='nextday'>" + nextDay + "</h2><dl>";

            for (var a = 0; a < occurrences2.count; a++) {
                var occurrence = occurrences2[a];
                var event = CalEventOccurrenceGetEvent(occurrence);
                var allday = CalEventIsAllDay(event);

                var summary = CalEventCopySummary(event);
                summary = CFAutoString(summary);

                events2.push({
                    isTodayOnly: "1",
                    isAllDay: allday,
                    date: CalEventOccurrenceGetDate(occurrence),
                    summary: summary
                });
            }

            events2.sort(function (lhs, rhs) {
                return lhs.date - rhs.date;
            });
        }

        if (occurrences != null) {
            calendarvars = "<h2>" + todayString + "</h2><dl>";

            for (var i = 0; i < occurrences.count; ++i) {
                var occurrence = occurrences[i];
                var event = CalEventOccurrenceGetEvent(occurrence);
                var allday = CalEventIsAllDay(event);

                var summary = CalEventCopySummary(event);
                summary = CFAutoString(summary);

                for (g = 0; g < events2.length; g++)
                    if (events2[g].summary == summary)
                        events2.splice(g, 1);

                events.push({
                    isTodayOnly:"0",
                    isAllDay:allday,
                    date: CalEventOccurrenceGetDate(occurrence),
                    summary: summary
                });
            }

            events.sort(function (lhs, rhs) {
                return lhs.date - rhs.date;
            });
        }

        for (var i = 0; i != events.length; ++i) {
            var event = events[i];

            if (event.isAllDay == true) {
                calendarvars += '<dt>';
                calendarvars += '<div class="dot" style="background-color: ';
                calendarvars += colors[0];
                calendarvars += ';"><img src="resources/images/icon_dot_overlay.png" width="8" height="7" /></div>';
                calendarvars += 'all-day</dt>';
            } else {
                var date = CFDateCreate(NULL, event.date);
                calendarvars += ELSaveDate(date, colors[i % colors.length], event.date);
                CFRelease(date);
            }

            calendarvars += '<dd>';
            calendarvars += event.summary;
            calendarvars += '</dd>';

            if (i == (events.length - 1)) {
                calendarvars += "</dl>";
            }
        }

        document.getElementById("calendar_events_info").innerHTML = calendarvars;

        for (var i = 0; i != events2.length; ++i) {
            var event = events2[i];

            if (event.isAllDay == true) {
                calendarvars2 += '<dt>';
                calendarvars2 += '<div class="dot" style="background-color: ';
                calendarvars2 += colors[0];
                calendarvars2 += ';"><img src="resources/images/icon_dot_overlay.png" width="8" height="7" /></div>';
                calendarvars2 += 'all-day</dt>';
            } else {
                var date = CFDateCreate(NULL, event.date);
                calendarvars2 += ELSaveDate(date, colors[i % colors.length], event.date);
                CFRelease(date);
            }

            calendarvars2 += '<dd>';
            calendarvars2 += event.summary;
            calendarvars2 += '</dd>';

            if (i == (events2.length - 1))
                calendarvars += "</dl>";
        }

        document.getElementById("calendar_events_info").innerHTML += calendarvars2;

        if (occurrences2 != null && events2.length < 1)
            document.getElementById("nextday").parentNode.removeChild(document.getElementById("nextday"));
    } else {
        setTimeout("getCalendar()", 1000);
    }
}

function launchApp(application) {
    if (LaunchApps == 1) {
        var allapps = [SBApplicationController.sharedInstance allApplications];
        appfind = [SBApplicationController sharedInstance];
        backgrounder = [appfind applicationWithDisplayIdentifier:"jp.ashikase.backgrounder"];
        var totalapps = allapps.count;

        for (var i = 0; i != totalapps; ++i) {
            var app = allapps[i];

            if (app->_pid != "-1") {
                if (backgrounder != null) {
                    sb = SpringBoard.sharedApplication;
                    [sb setBackgroundingEnabled:1 forDisplayIdentifier:app->_bundleIdentifier];
                }

                [app kill];
                [app deactivate];
            }
        }

        setTimeout("launchNow('" + application + "')", 400);
    }
}

function launchNow(app) {
    [SBAwayController.sharedAwayController unlockWithSound:NO];
    [[[SBIconModel sharedInstance] iconForDisplayIdentifier:app] launch];
}

function updateAttributes(tag) {
    elements = document.getElementsByTagName(tag);
    for (var h = 0; h != elements.length; ++h)
        elements[h].onclick = "resetTimeout()";
}

function resetTimeout() {
    [SBAwayController.sharedAwayController restartDimTimer:IdleTimeout];
}

function fetchWeatherData(citynum, weatherErrorCount) {
    if (typeof(citynum) == "undefined")
        ctnum = 0;
    else
        ctnum = citynum;

    plist = [NSDictionary dictionaryWithContentsOfFile:"/User/Library/Preferences/com.apple.weather.plist"];
    citiescount = plist.Cities.count;

    if (citiescount == 0) {
        document.getElementById("weatherdiv").innerHTML = "<span class='hi_lo'><br>Weather not set.<br>Select a city<br>in Weather app.</span>";
        break;
    }

    if (ctnum <= citiescount) {
        city = plist.Cities[ctnum]["Zip"];
        city = city.toString().split("|");

        if (weatherErrorCount == 0 || typeof(weatherErrorCount) == "undefined") {
            city = city[1];
        } else {
            city = city[0];
        }

        cityname = plist.Cities[ctnum]["Name"]
        unit = plist.Celsius;

        if (unit == "0") { unit = "f" } else { unit = "c" }

        if (weatherErrorCount == 0 || typeof(weatherErrorCount) == "undefined") {
            weatherUrl = "http://weather.yahooapis.com/forecastrss?w=" + city + "&u=" + unit + "&dump=l";
        } else {
            weatherUrl = "http://weather.yahooapis.com/forecastrss?p=" + city + "&u=" + unit + "&dump=l";
        }

        xmlHttp = new XMLHttpRequest();

        var url = weatherUrl;
        url = url + "?sid=" + Math.random();

        xmlHttp.onreadystatechange = function() {
            weatherString = xmlHttp.responseText;
            getWeather();
        }

        xmlHttp.open("GET", url, true);
        xmlHttp.send(null);

        weatherInfo = [];
    } else {
        document.getElementById("weatherdiv").innerHTML = "<span class='hi_lo'><br>Weather data<br>unavailable for<br>" + cityname + "</span>";
        break;
    }
}

var weathererror = 0;

function getWeather() {
    if (weatherString != "") {
        if (weatherString.search("Invalid") > -1 && weathererror == 0) {
            weathererror = 1;
            fetchWeatherData(ctnum, 1);
            break;
        }

        if (weatherString.search("Invalid") > -1 && weathererror == 1) {
            weathererror = 0;
            var nextcity = ctnum + 1;
            fetchWeatherData(nextcity, 0);
            break;
        }

        weatherString = weatherString.split(">\n");

        for (var i = 0; i != weatherString.length; ++i) {
            if (weatherString[i].search("yweather:forecast") > -1) {
                forecast = weatherString[i];
                forecast = forecast.split(" ");

                for (s = 0; s < forecast.length; s++) {
                    if (forecast[s].search("high") > -1) {
                        high = forecast[s];
                        high = high.replace('high="', '');
                        high = high.replace('"', '');
                        weatherInfo["high"] = high;
                    }

                    if (forecast[s].search("low") > -1) {
                        low = forecast[s];
                        low = low.replace('low="', '');
                        low = low.replace('"', '');
                        weatherInfo["low"] = low;
                    }
                }

                break;
            }

            weatherString[i] = weatherString[i].replace(/</i, "");
            weatherString[i] = weatherString[i].replace(/>/i, "");

            if (weatherString[i].search("yweather:location") > -1) {
                cityline = weatherString[i];
                cityline = cityline.split(" ");

                if (cityline[2].search(/region/gi) < 0) {
                    extracity = cityline[2];
                } else {
                    extracity = "";
                }

                cityline = cityline[1];
                cityline += " " + extracity;
                cityline = cityline.replace('city="', '');
                cityline = cityline.replace('"', '');

                if (cityline.length > 9) {
                    cityline = cityline.substr(0, 8);
                    cityline += "...";
                }

                weatherInfo["city"] = cityline;
            }

            if (weatherString[i].search("yweather:condition") > -1) {
                condition = weatherString[i];
                condition = condition.split(" ");

                for (x = 0; x < condition.length; x++) {
                    if (condition[x].search("code") > -1) {
                        code = condition[x];
                        code = code.replace('code="', '');
                        code = code.replace('"', '');
                        weatherInfo["code"] = code;
                    }

                    if (condition[x].search("temp") > -1) {
                        temp = condition[x];
                        temp = temp.replace('temp="', '');
                        temp = temp.replace('"', '');
                        weatherInfo["temp"] = temp;
                    }
                }
            }

            if (weatherString[i].search("yweather:condition") > -1) {
                conditionStatus = weatherString[i];
                conditionStatus = conditionStatus.split('"');

                for (x = 0; x < conditionStatus.length; x++) {
                    if (conditionStatus[x].search("text") > -1) {
                        next = x + 1;

                        status = conditionStatus[next].toString();
                        if (status.length > 17) {
                            status = status.substr(0, 17);
                            status += '...';
                        }

                        weatherInfo["status"] = status;

                    }
                }
            }
        }

        var weatherResults = "<a href='javascript:void(0)' onclick='moveWeather()'><img src='resources/images/weather/" + code + ".png' class='icon'>";
        weatherResults += "<div class=info><span class='city'>" + weatherInfo.city + "</span>";
        weatherResults += "<span class='temp'> " + weatherInfo.temp + "&#730;</span>";
        weatherResults += "<span class='hi_lo'>H " + weatherInfo.high + "&#730; L " + weatherInfo.low + "&#730;</span></div></a>";
        //weatherResults+="<span class='status'>" + weatherInfo.status + "</span>";

        document.getElementById("weatherdiv").innerHTML = weatherResults;
        [weatherResults writeToFile:"/User/Library/Element/cache/weather.Element" atomically:YES];
        try { clearTimeout(weatherTimer); } catch(err) {}
    } else {
        weatherTimer = setTimeout("getWeather()", 500);
    }
}

function call(number) {
    savedAddress = document.getElementById(number).innerHTML;
    savedType = document.getElementById(number + "type").innerHTML;
    document.getElementById(number).innerHTML = number;

    if (AllowDialing == 1) {
        document.getElementById(number + "type").innerHTML = "<img src='resources/images/callicon.png' style='margin-right:7px'>";
        document.getElementById(number + "type").setAttribute("onclick", "dialNumber('" + number + "')");
        document.getElementById(number).setAttribute("onclick", "reshowAddress('" + savedAddress + "', '" + number + "', '" + savedType + "')");
    }

    setTimeout("reshowAddress('" + savedAddress + "', '" + number + "', '" + savedType + "')", 1500);
}

function reshowAddress(address, div, type) {
    var element = document.getElementById(div);
    element.innerHTML = address;
    element.setAttribute("onclick", "call('" + div + "')");

    var element = document.getElementById(div + "type");
    element.innerHTML = type;
    element.setAttribute("onclick", "");
}

function dialNumber(number) {
    [[SBAwayController sharedAwayController] unlockWithSound:NO];
    [SBTTYPromptAlert dialNumberPromptingIfNecessary:number addressBookUID:-1 urlAddition:"wasLockAlert=1"];
}

function launchUrl(url) {
    if (AllowOpenSMS == 1) {
        view = [SBAwayController.sharedAwayController awayView];
        launch = [NSURL URLWithString:url];
        [view launchURL:launch];
    }
}

function moveWeather(interval) {
    ctnum = ctnum + 1;
    if (ctnum >= citiescount) {
        ctnum = 0;
    }

    fetchWeatherData(ctnum, 0);
    if (interval != null && interval != "undefined") {
        setTimeout("moveWeather('" + interval + "')", interval);
    }
}

function checkPasscode() {
    if (document.getElementById("passCodeField").value.length == 4) {
        var passcode = [SBAwayController.sharedAwayController devicePasscode];

        if (document.getElementById("passCodeField").value == passcode.toString()) {
            document.getElementById("protector").style.visibility = 'hidden';
        } else {
            document.getElementById("passCodeText").innerHTML = '<span style="color:#cc0000;">Wrong Passcode!</span><br>Enter Passcode:';
            document.getElementById("passCodeField").value = "";
        }
    }
}

function ELDisplayClock() {
    CFDateFormatterSetFormat(formatter, UIDateFormatStringForFormatType(UINoAMPMTimeFormat));

    var string = CFDateFormatterCreateStringWithDate(NULL, formatter, now);

    document.write('<span class="clock">');
    document.write(string);
    document.write('</span>');

    CFRelease(string);

    CFDateFormatterSetFormat(formatter, UIDateFormatStringForFormatType(UIWeekdayNoYearDateFormat));

    var string = CFDateFormatterCreateStringWithDate(NULL, formatter, now);

    document.write('<span class="date">');

    if (string.length > 21) {
        CFRelease(string);
        CFDateFormatterSetFormat(formatter, UIDateFormatStringForFormatType(UIWeekdayAbbreviatedNoYearDateFormat));
        var string = CFDateFormatterCreateStringWithDate(NULL, formatter, now);
    }

    document.write(string);
    CFRelease(string);

    document.write('</span>');
}

function ELDisplayWeather() {
    weatherCachedContents = [NSString stringWithContentsOfFile:"/User/Library/Element/cache/weather.Element"];
    if (weatherCachedContents != null)
        document.write(weatherCachedContents.toString());
}

function ELDisplayMissedCallsHeader() {
    if (iPhone)
        document.write("<span>" + missedString + "</span>");
}

function ELDisplayMissedCallsFooter() {
    if (iPhone && MissedCallsEnabled == 1) {
        callbadge = [[SBIconModel.sharedInstance iconForDisplayIdentifier:"com.apple.mobilephone"] badgeValue];
        if (callbadge > 0)
            document.getElementById("callcount").innerHTML = "(" + callbadge + ")";

        var calls = CTCallCopyAllMissedCallsAfterRowID(NULL, 0);

        var count = calls.length;
        if (count > noOfMissedCalls)
            count = noOfMissedCalls;

        var start = new double;
        var label = new int;

        for (var i = 0; i != count; ++i) {
            var call = calls[i];

            document.write('<dt>');

            CTCallGetStartTime(call, start);

            var date = CFDateCreate(NULL, *start);

            if (i < parseInt(callbadge)) {
                document.write("<div style='display:inline;color:#f9ca0e'>");
                ELPrintDate(date);
                document.write("</div>");
            } else {
                ELPrintDate(date);
            }

            CFRelease(date);

            document.write('<dd>');

            var address = CTCallCopyAddress(NULL, call);
            address = CFAutoString(address);

            var number, type = null;

            if (address.length == 0)
                number = "Blocked";
            else {
                *label = 0;
                var person = ABCFindPersonMatchingPhoneNumberWithCountry(book, address, code, NULL, label);

                if (person == null)
                    number = UIFormattedPhoneNumberFromString(address);
                else {
                    number = ABCRecordCopyCompositeName(person);
                    number = CFAutoString(number);

                    if (number.length > 15)
                        number = number.substr(0, 15) + "...";
                }

                if (*label != 0) {
                    type = ABCCopyLocalizedPropertyOrLabel(*label);
                    type = CFAutoString(type);
                }
            }

            if (address.length > 0)
                document.write("<a id=" + address + " href='javascript:void(0)' onclick='call(\"" + address + "\")'>" + number + "</a>");
            else
                document.write(number);

            document.write(' <div class="num_type" id=' + address + 'type style="float:right">');

            if (type != null)
                document.write('(' + type + ')');

            document.write('</div>');

            // document.write(' <img src="resources/images/icon_voice_mail_inline.png" width="18" height="17" alt="Voicemail" class="vm" /></dd>');
            document.write('</dd>');
        }

        free(label);
        free(start);

        CFRelease(calls);
    } else {
        document.getElementById("missed_calls").style.display = "none";
        document.getElementById("missed_calls").style.visibility = "hidden";
    }

    if (statusarray != null && statusarray.missed_calls.toString() == "contracted")
        ELToggleDiv("missed_calls");
}

function ELDisplayCalendarHeader() {
    document.write('<div class="icon" id="datediv">');
    document.write(new Date().getDate());
    document.write('</div>');

    document.write("<span>" + calendarString + "</span>");
}

function ELDisplayCalendarFooter() {
    if (CalendarEventsEnabled == 1) {
        calContents = [NSString stringWithContentsOfFile:"/User/Library/Element/cache/calendar.Element"];
        if (calContents != null)
            document.write(calContents);
        if (statusarray != null && statusarray.calendar_events == "contracted")
            ELToggleDiv("calendar_events");
    } else {
        document.getElementById("calendar_events").style.display = "none";
    }
}

function ELDisplayMail() {
    if (EmailsEnabled == 1) {
        var contents = [NSString stringWithContentsOfFile:"/User/Library/Element/cache/latestmails.Element"];
        if (contents != null)
            document.write(contents);
        if (statusarray != null && statusarray.email == "contracted")
            ELToggleDiv("email");
    } else {
        document.getElementById("email").style.display = "none";
    }
}

function ELDisplayTextHeader() {
    if (iPhone)
        document.write("<span>" + SMSString + "</span>");
}

function ELDisplayTextFooter() {
    if (iPhone && SMSEnabled == 1) {
        var smsbadge = [[SBIconModel.sharedInstance iconForDisplayIdentifier:"com.apple.MobileSMS"] badgeValue];
        if (smsbadge > 0)
            document.getElementById("sms_count").innerHTML = "(" + smsbadge + ")";

        var smsService = [CKSMSService sharedSMSService];

        var conversations = smsService.conversationList;
        [conversations resort];
        conversations = [conversations conversations];

        var count = [conversations count];
        limitedcount = 0;
        for (var i = 0; i != count; ++i) {
            if (limitedcount > noOfSMS - 1)
                break;

            var conversation = conversations[i];

            var message = conversation.latestIncomingMessage;

            if (message != null)
                limitedcount++;
            else
                continue;

            if (isNaN(message.address))
                document.write('<a href="javascript:void(0)">');
            else
                document.write('<a href="javascript:void(0)" onclick="launchUrl(\'sms:' + message.address + '\')">');

            var unread = [smsService unreadCountForConversation:conversation] > 0;

            if (unread)
                document.write("<span style='color:#f9ca0e'>");
            ELPrintDate(message.date);
            if (unread)
                document.write("</span>");

            document.write('<dd>');
            document.write(conversation.name);
            document.write('<p>');
            document.write(message.text);
            document.write('</p>');
            document.write('</dd>');

            document.write("</a>");

            document.write('<p></p>');
        }
    } else {
        document.getElementById("sms").style.display = "none";
        document.getElementById("sms").style.visibility = "hidden";
    }

    if (statusarray != null && statusarray.sms.toString() == "contracted")
        ELToggleDiv("sms");
}

function ELDisplayFacebook() {
    appman = [SBApplicationController sharedInstance];
    app = [appman applicationWithDisplayIdentifier:"com.facebook.Facebook"];

    if (app != null && FacebookEnabled == 1) {
        fbpath = app->_seatbeltEnvVars.HOME;
        fbplistpath = fbpath + "/Library/Preferences/com.facebook.Facebook.plist";
        fbplist = [NSDictionary dictionaryWithContentsOfFile:fbplistpath];

        lastmessage = fbplist.FBLastNotificationMessage;

        messagetime = fbplist.FBLastNotificationTime;
        messagetime = messagetime.toString();

        fbInbox = fbplist.FBInboxUnreadCount;
        fbRequest = fbplist.FBRequestsCount;

        dateFormatter = [new NSDateFormatter init];
        [dateFormatter setDateFormat:"yyyy-mm-dd HH:mm:ss ZZZZ"];

        fbtime = [dateFormatter dateFromString:messagetime];
        FBmessageTime = ELSaveDate(fbtime);

        if (fbRequest > 0)
            document.write("<dt><img align='center' src='resources/images/icon_addFriend.png'></dt><dd>" + fbRequest + " Friend Requests</dd>");

        if (fbInbox > 0)
            document.write("<dt><img align='center' src='resources/images/icon_inbox.png' width='18'></dt><dd>" + fbInbox + " unread messages</dd>");

        document.write(FBmessageTime);
        document.write("<dd>" + lastmessage + "</dd>");
        fbtotals = fbRequest + fbInbox;

        if (fbtotals > 0)
            document.getElementById("facebook_count").innerHTML = "(" + fbtotals + ")";

        if (statusarray != null && statusarray.facebook == "contracted")
            ELToggleDiv("facebook");
    } else {
        document.getElementById("facebook").style.display = 'none';
        document.getElementById("facebook").style.visibility = 'hidden';
    }
}

function ELDisplayStocks() {
    if (StocksEnabled == 1) {
        stockplist = [NSDictionary dictionaryWithContentsOfFile:"/User/Library/Preferences/com.apple.stocks.plist"];

        if (stockplist != null) {
            document.write("<table>");

            for (var i = 0, count = Math.min(stockplist.stocks.count, 3); i != count; ++i) {
                symbol = stockplist.stocks[i].symbol;
                price = stockplist.stocks[i].price;
                change = stockplist.stocks[i].change;

                if (change >= 0)
                    color = "rgb(81, 187, 53)";
                else
                    color = "#cc0000";

                symbolcolor = ['rgb(160, 2, 251)', 'rgb(246, 157, 9)', 'rgb(81, 187, 53)'];
                symbolcolor = symbolcolor[i % symbolcolor.length];

                document.write('<tr><td class="symbol">' + symbol + '</td><td class="price">' + price + '</td>');
                document.write('<td class="percentage_change rising">' + change + '</td></tr>');
            }
        }

        document.write("</table>");

        if (statusarray != null && statusarray.stocks == "contracted")
            ELToggleDiv("stocks");
    } else {
        document.getElementById('stocks').style.display = 'none';
    }
}

function ELDisplayFooter() {
    if (EmailsEnabled == 1)
        setTimeout("checklockedmail()", 3000);
    if (CalendarEventsEnabled == 1)
        getCalendar();

    resetTimeout();

    //updateAttributes("div");
    //updateAttributes("a");

    fetchWeatherData();

    calendarResults = document.getElementById("calendar_events_info").innerHTML;
    [calendarResults writeToFile:"/User/Library/Element/cache/calendar.Element" atomically:YES];

    if (SMSEnabled != 1 && EmailsEnabled != 1 && MissedCallsEnabled != 1 && CalendarEventsEnabled != 1 && StocksEnabled != 1 && FacebookEnabled != 1) {
        document.body.style.backgroundImage = "url('/User/Library/LockBackground.jpg')";
        document.getElementById("master_div").style.background = "none";
        document.getElementById("time_weather").style.background = "none";
        document.getElementById("master_div").style.opacity = "0.8";
    }

    if (RotateWeather == 1) {
        setInterval = RotateWeatherInterval * 1000;
        setTimeout("moveWeather('" + setInterval + "')", setInterval);
    }
}

document.addEventListener("DOMContentLoaded", ELDisplayFooter);

defaultsPlist = [NSDictionary dictionaryWithContentsOfFile:"/User/Library/Preferences/com.saurik.element.plist"];

if (defaultsPlist != null) {
    noOfSMS = defaultsPlist.noOfSMS;
    noOfMissedCalls = defaultsPlist.noOfMissedCalls;
    noOfEmails = defaultsPlist.noOfEmails;
    SMSEnabled = defaultsPlist.SMSEnabled;
    EmailsEnabled = defaultsPlist.EmailsEnabled;
    FacebookEnabled = defaultsPlist.FacebookEnabled;
    StocksEnabled = defaultsPlist.StocksEnabled;
    CalendarEventsEnabled = defaultsPlist.CalendarEventsEnabled;
    MissedCallsEnabled = defaultsPlist.MissedCallsEnabled;
    LaunchApps = defaultsPlist.LaunchApps;
    ExpandContract = defaultsPlist.ExpandContract;
    AllowDialing = defaultsPlist.AllowDialing;
    AllowOpenSMS = defaultsPlist.AllowOpenSMS;
    RotateWeather = defaultsPlist.RotateWeather;
    RotateWeatherInterval = defaultsPlist.RotateWeatherInterval;
    IdleTimeout = defaultsPlist.IdleTimeout;
} else {
    noOfSMS = 3;
    noOfMissedCalls = 3;
    noOfEmails = 5;
    SMSEnabled = 1;
    EmailsEnabled = 1;
    FacebookEnabled = 1;
    StocksEnabled = 1;
    CalendarEventsEnabled = 1;
    MissedCallsEnabled = 1;
    LaunchApps = 0;
    ExpandContract = 0;
    AllowDialing = 1;
    AllowOpenSMS = 1;
    RotateWeather = 0;
    RotateWeatherInterval = 5;
    IdleTimeout = 20.00;

    savedict = [new NSMutableDictionary init];
    [savedict setObject:3 forKey:"noOfSMS"];
    [savedict setObject:3 forKey:"noOfMissedCalls"];
    [savedict setObject:5 forKey:"noOfEmails"];
    [savedict setObject:1 forKey:"SMSEnabled"];
    [savedict setObject:1 forKey:"EmailsEnabled"];
    [savedict setObject:1 forKey:"FacebookEnabled"];
    [savedict setObject:1 forKey:"StocksEnabled"];
    [savedict setObject:1 forKey:"CalendarEventsEnabled"];
    [savedict setObject:1 forKey:"MissedCallsEnabled"];
    [savedict setObject:0 forKey:"LaunchApps"];
    [savedict setObject:0 forKey:"ExpandContract"];
    [savedict setObject:1 forKey:"AllowDialing"];
    [savedict setObject:1 forKey:"AllowOpenSMS"];
    [savedict setObject:0 forKey:"RotateWeather"];
    [savedict setObject:5 forKey:"RotateWeatherInterval"];
    [savedict setObject:20.00 forKey:"IdleTimeout"];
    [savedict writeToFile:"/User/Library/Preferences/com.saurik.element.plist" atomically:YES];
}

// Useful Globals {{{
var model = [[UIDevice currentDevice] model].toString();
var iPhone = model == "iPhone";

var book = ABCGetSharedAddressBook();

var zone = CFTimeZoneCopyDefault();
zone = CFAutoObject(zone);

if (iPhone) {
    var code = CPPhoneNumberCopyNetworkCountryCode();
    code = CFAutoString(code);
}

var time = CFAbsoluteTimeGetCurrent();

var now = CFDateCreate(NULL, time);
now = CFAutoObject(now);

var locale = CFLocaleCopyCurrent();
var formatter = CFDateFormatterCreate(NULL, locale, kCFDateFormatterNoStyle, kCFDateFormatterNoStyle);
formatter = CFAutoObject(formatter);
CFRelease(locale);

var bundle = [NSBundle mainBundle];
// }}}

var todayString = decomposedString("CALENDAR_TODAY", "Today");
var tomorrowString = decomposedString("CALENDAR_TOMORROW", "Tomorrow");
var yesterdayString = decomposedString("CALENDAR_YESTERDAY", "Yesterday");

var daysAgoString = [[NSBundle bundleWithIdentifier:"com.apple.mobilenotes"] localizedStringForKey:"DAYS_AGO_FORMAT" value:"%@ days ago" table:"Main"];
daysAgoString = [[NSString stringWithString:daysAgoString] decomposedStringWithCanonicalMapping].toString();
daysAgoString = daysAgoString.replace("%@", "");

var calendarString = [[NSBundle bundleWithIdentifier:"com.apple.mobilecal"] localizedStringForKey:"UISettingsDisplayName" value:"Calendar" table:"InfoPlist"].toString();

if (iPhone) {
    var missedString = [[NSBundle bundleWithIdentifier:"com.apple.mobilephone"] localizedStringForKey:"MULTI_MISSED_CALLS_FORMAT" value:"%i Missed Calls" table:"Recents"];
    missedString = [[NSString stringWithString:missedString] capitalizedString].toString();
    missedString = missedString.replace("%I", "");

    var SMSString = [bundle localizedStringForKey:"AWAY_MASKED_SMSES_LABEL" value:"Text Messages" table:"SpringBoard"];
} else {
    var missedString = "";
    var SMSString = "";
}

var stockString = [[NSBundle bundleWithIdentifier:"com.apple.stocks"] localizedStringForKey:"Stocks" value:null table:"Localizable"];

statusarray = [NSDictionary dictionaryWithContentsOfFile:"/User/Library/Element/cache/laststate.Element"];

var manager = [NSFileManager defaultManager];
if (![manager fileExistsAtPath:"/User/Library/Element/cache"])
    [manager createDirectoryAtPath:"/User/Library/Element/cache" withIntermediateDirectories:YES attributes:NULL error:NULL];
